// Eric rutherford
// started Sept. 8, 1998
// edited  March 27, 2001
// Doom-Gaze's Diablo Trainer

//Healer items....6A7EF0
//Smith magical items.....6A05C0
//Smith normal items....6A9D70
//Witch items...6A6228
//Wirt item.....6A0448

#define RELVERSION		"v1.09a+ (FINAL)"
#define RELDATE			"(5/26/01)"
#define RELTEXT			"Supported Versions:\n"\
						"Diablo v1.07 Retail + Mods\n"\
						"Diablo v1.08 Retail + Mods\n"\
						"Diablo v1.09 Retail + Mods\n"\
						"Author: Eric Rutherford\n"\
						"(aka Doom-Gaze)\n"\
						"Info/Questions/Comments:\n"\
						"http://www.delinquentminds.com"

#include "includes.h"
#include "spellnames.h"
#include "dsdata.h"

//Diablo v1.07
#define GROUND_7		6516040
#define VERSTR_7		4781512
#define CHARSLOT_7		6846324
#define CHAROFFSET_7	6846520
#define NAMEOFFSET_7	6846648
#define DIABLOVERSION_7	"Diablo v1.07"

//Diablo v1.08
#define GROUND_8		6519480
#define VERSTR_8		4785452
#define CHARSLOT_8		6849684
#define CHAROFFSET_8	6849880
#define NAMEOFFSET_8	6850008
#define DIABLOVERSION_8	"Diablo v1.08"

//Diablo v1.09
#define GROUND_9		0x635a28
#define VERSTR_9		0x48E58C
#define CHARSLOT_9		0x686444
#define CHAROFFSET_9	0x686508
#define NAMEOFFSET_9	0x686588
#define DIABLOVERSION_9	"Diablo v1.09"

#define TIMER_START		2
#define TIMER_REFRESH	3
#define TIMER_SPLASH	4
#define TIMER_ICON		5

#define CHAHEADER		"DIABLO CHAR FILE\x0D\x0A\x31\x1A"
#define ITMHEADER		"ITM01.I\'ll get that al\'Thor!\0\0\0"


//#define HANDITEM		6867504

// global vars
HANDLE hDiablo=NULL;	// diablo process ID
HWND hDiabloWnd=NULL;	// Diablo Window

int GROUND;
int VERSTR;
int CHARSLOT;
int CHAROFFSET;
int NAMEOFFSET;
char DIABLOVERSION[20];

HINSTANCE hInstance;
HWND hEditDlg;			// handle to edit Dialog
HWND hMainDlg;			// handle to main Dialog
HWND hAboutDlg;			// handle to about Dialog
HWND hItemDlg;
HWND hGrndItmDlg;
HWND hHacksDlg;
HWND hSplashWnd=NULL;	// handle to splash window
char *g_CmdLine;
_CharStruct *g_pCharacter;
_ItemStruct *g_pItem;
char *g_pTempChar = NULL;		// holds your character information temporarily


// prototypes
BOOL WINAPI MainDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL WINAPI CompDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL WINAPI AboutDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL WINAPI EditDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL WINAPI ItemDlgProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam);
BOOL WINAPI GrndDlgProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam);
BOOL WINAPI HacksDlgProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam);
BOOL WINAPI FilesDlgProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam);
long WINAPI SplashWndProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam);
BOOL GetFileName(HWND hWnd, LPSTR pszBuffer, DWORD dwBufLen, LPCSTR pszFilter, LPCSTR pszDefExt, BOOL fSave);
BOOL RestoreChar();
BOOL InitHacks(char *FileName);
BOOL SaveChar();
BOOL GetDiabloProcID();
short Refresh();
BOOL DisableDlg();
BOOL ExportItem(int index,_CharStruct *pCharacter);
BOOL ImportItem(int index,_CharStruct *pCharacter);
BOOL DeleteItem(int index,_CharStruct *pCharacter);
BOOL EditItem(int index, _CharStruct *pCharacter);
int AllocPos(char *ItemPos,unsigned int *NumbOfItems,int ItemSlot);
BOOL CheckPosition(int Pos,char *ItemPos);
BOOL OpenCharFile();
BOOL OpenItemFile();
BOOL WriteCharFile();
BOOL WriteItemFile();
BOOL RegisterFileType(const char *szFileExt, const char *szFileType, const char *szFileDesc, int nIcon);
void PickUpItemProc(LPARAM index);
void ActivateHacksProc(LPARAM pHack);
void DeactivateHacksProc(LPARAM pHack);
int MsgBox(HWND, char*, int,char*, ... );
void Initialize();
void TabInsert(HWND hTabControl, int Item, LPSTR Tag);
BOOL WINAPI ItemTab0Proc(HWND hDlg, int Msg, WPARAM wParam, LPARAM lParam);
BOOL WINAPI ItemTab1Proc(HWND hDlg, int Msg, WPARAM wParam, LPARAM lParam);
BOOL WINAPI ItemTab2Proc(HWND hDlg, int Msg, WPARAM wParam, LPARAM lParam);

// WinMain - point of entry
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR CmdLine, int CmdShow)
{
	InitCommonControls();
	hInstance=hInst;

	if(CmdLine[0])
	{
		char szTemp[5];
		strncpy(szTemp,&CmdLine[strlen(CmdLine)-4],5);
		g_CmdLine = new char[256];
		strcpy(g_CmdLine,CmdLine);
		if(!stricmp(".cha",szTemp))
			if(OpenCharFile())
				DialogBoxParam(hInstance,MAKEINTRESOURCE(IDD_EDITDLG),NULL,(FARPROC)EditDlgProc, (LPARAM) 100);
		if(!stricmp(".itm",szTemp))
			if(OpenItemFile())
				if(DialogBox(hInstance,MAKEINTRESOURCE(IDD_ITEMDLG),NULL,(FARPROC)ItemDlgProc))
					WriteItemFile();
		if(!stricmp(".dat",szTemp))
			InitHacks(g_CmdLine);
		delete [] g_CmdLine;
		return TRUE;
	}

	
	MSG msg;
	WNDCLASS wc;
	wc.lpszClassName = "SplashClass";
	wc.lpfnWndProc = SplashWndProc;
	wc.style = CS_VREDRAW | CS_HREDRAW;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon( NULL, IDI_APPLICATION );
	wc.hCursor = LoadCursor( NULL, IDC_ARROW );
	wc.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszMenuName = NULL;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	RegisterClass( &wc );
	hSplashWnd = CreateWindowEx(WS_EX_TOPMOST,
								"SplashClass",
								"Doom-Gaze's Diablo Trainer",
								WS_POPUP,
								GetSystemMetrics(SM_CXSCREEN)/2-250,
								GetSystemMetrics(SM_CYSCREEN)/2-50,
								500,
								100,
								NULL,
								NULL,
								hInstance,
								NULL);

	if(hSplashWnd)
	{
		ShowWindow(hSplashWnd, CmdShow);
		while(GetMessage(&msg,NULL,0,0))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	
	DialogBox(hInst,MAKEINTRESOURCE(IDD_MAINDLG),NULL,(FARPROC)MainDlgProc);
	return msg.wParam;
}

// Process Main Dlg messages
BOOL WINAPI MainDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	char *HackFile;
	char *pCharBuffer; // holds switch chars info temporarily
	char *szModuleFileName;
	int Slot, YourSlot;
	MENUITEMINFO mii;

	switch(msg)
	{
		case WM_INITDIALOG:
			HICON hDiabloIcon;
			hDiabloIcon = LoadIcon(hInstance,MAKEINTRESOURCE(IDI_DIABLO));
			SendMessage(hDlg, WM_SETICON, (WPARAM) ICON_BIG | ICON_SMALL , (LPARAM) (HICON) hDiabloIcon);
			hMainDlg=hDlg;
			mii.cbSize = sizeof(MENUITEMINFO);
			mii.fMask = MIIM_TYPE | MIIM_ID;
			mii.wID = IDC_ABOUTBUTTON;
			mii.fType = MFT_STRING | MFT_RIGHTJUSTIFY;
			mii.dwTypeData = RELVERSION;
			mii.cch = strlen(RELVERSION)+1;
			InsertMenuItem(GetMenu(hDlg),IDC_ABOUTBUTTON,FALSE,&mii);
			DrawMenuBar(hDlg);
			CheckRadioButton(hDlg,IDC_PLAYER1,IDC_PLAYER4,IDC_PLAYER1);
			if(!GetDiabloProcID())
				return DisableDlg();
			Refresh();
			return TRUE;
 
		case WM_DESTROY:

			CloseHandle(hDiablo);
			return TRUE;

		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
// Open a file
				case IDC_FILE_OPEN:
					HackFile = new char[256]; // not nessisarily a hack file but can be
					ZeroMemory(HackFile, 256);
					if(!GetFileName(hMainDlg, HackFile, 255,
						"All Diablo Data files\0*.cha;*.itm;*.dat\0Diablo Character Files (*.cha)\0*.cha\0Diablo Item Files (*.itm)\0*.itm\0Diablo Hack Data Files (*.dat)\0*.dat\0All Files (*.*)\0*.*\0",
						"any", FALSE)) { delete [] HackFile; return TRUE; }
					szModuleFileName = new char[256];
					GetModuleFileName(hInstance, szModuleFileName, 255);
					ShellExecute(NULL,"open",szModuleFileName,HackFile,NULL,SW_SHOWNORMAL);
					delete [] HackFile;
					delete [] szModuleFileName;
					return TRUE;
// switch character!
				case IDC_SWITCHEM:
					if(!GetDiabloProcID())
						return DisableDlg();
					Slot = Refresh();
					if(Slot==-1)
						return MessageBox(hMainDlg,"Unavailable Slot","Error",MB_OK | MB_ICONERROR);
					ReadProcessMemory(hDiablo,(void*)(CHARSLOT),(void*)&YourSlot,4,NULL);
					if(!g_pTempChar)
					{
						g_pTempChar = new char[21044];
						ReadProcessMemory(hDiablo,(void*)(CHAROFFSET+YourSlot*21720),g_pTempChar,21044,NULL);
					}
					pCharBuffer = new char[21044];
					ReadProcessMemory(hDiablo,(void*)(CHAROFFSET+Slot*21720),pCharBuffer,21044,NULL);
					WriteProcessMemory(hDiablo,(void*)(CHAROFFSET+YourSlot*21720),pCharBuffer,21044,NULL);
					return TRUE;
				
// get ground items
				case IDC_GROUNDED:
					if(!GetDiabloProcID())
						return DisableDlg();
					Refresh();
					DialogBox(hInstance,MAKEINTRESOURCE(IDD_GROUNDDLG),hMainDlg,(FARPROC) GrndDlgProc);
					return TRUE;
// hacks
				case IDC_HACKS:
					if(!GetDiabloProcID())
						return DisableDlg();
					Refresh();
					if(!hHacksDlg)
					{
						HackFile = new char[256];
						ZeroMemory(HackFile, 256);
						
						if(!GetFileName(hMainDlg, HackFile, 255,
							"Diablo Hack Data files (*.dat)\0*.dat\0All Files (*.*)\0*.*\0",
							"dat", FALSE))
							return TRUE;
						InitHacks(HackFile);
						delete [] HackFile;
					}
					else
						SetFocus(hHacksDlg);
					return TRUE;


// save
				case IDC_SAVEBUTTON:
					return SaveChar();

// restore				
				case IDC_RESTOREBUTTON:
               return RestoreChar();
// edit
				case IDC_EDITBUTTON:
					if(!GetDiabloProcID())
						return DisableDlg();
					Slot = Refresh();
					if(Slot==-1)
						return MessageBox(hMainDlg,"Unavailable Slot","Error",MB_OK | MB_ICONERROR);
					if(DialogBoxParam(hInstance,MAKEINTRESOURCE(IDD_EDITDLG),hMainDlg,(FARPROC)EditDlgProc, (LPARAM) Slot))
					{
						Refresh();
						return MessageBox(hMainDlg,"Character Changed","Success",MB_OK);
					}
					return TRUE;

// quit
				case IDCANCEL:
               /*if (MessageBox(hDlg,"Do you really want to quit?","Confirm",MB_ICONQUESTION|MB_YESNO)==IDYES)*/ EndDialog(hDlg,FALSE);
         		return TRUE;
// refresh				
				case IDC_REFRESHBUTTON:
					if(!GetDiabloProcID())
						return DisableDlg();
					Refresh();
					return TRUE;
// about
				case IDC_ABOUTBUTTON:
						DialogBox(hInstance,MAKEINTRESOURCE(IDD_ABOUTDLG),hMainDlg,(FARPROC)AboutDlgProc);
					return TRUE;

				default:
					return FALSE;
			}
		default:
			return FALSE;
	}
}

// Make Common Dialog to get file name for saving and opening
BOOL GetFileName(HWND hWnd, LPSTR pszBuffer, DWORD dwBufLen, LPCSTR pszFilter, LPCSTR pszDefExt, BOOL fSave)
{
	char *Path;
	char *szIniFileName;
	szIniFileName = new char[256];
	Path = new char[256];
	GetModuleFileName(hInstance, szIniFileName, 255);
	strcpy(szIniFileName+(strlen(szIniFileName)-4),".INI");
	char FileName[33];
	ZeroMemory(FileName,33);
	BOOL ret;
	OPENFILENAME ofn;
	memset(&ofn, 0, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	GetPrivateProfileString("Path", pszDefExt, FileName, Path, 255, szIniFileName);
	ofn.lpstrInitialDir = Path;
	ofn.hwndOwner = hWnd;
	ofn.hInstance = hInstance;
	ofn.lpstrFilter = pszFilter;
	ofn.lpstrFile = pszBuffer;
	ofn.lpstrFileTitle = FileName;
	ofn.nMaxFile = dwBufLen;
	if (fSave)
		ofn.Flags = OFN_PATHMUSTEXIST|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;
	else
		ofn.Flags = OFN_FILEMUSTEXIST|OFN_HIDEREADONLY;
	ofn.lpstrDefExt = pszDefExt;
	ret = fSave ? GetSaveFileName(&ofn) : GetOpenFileName(&ofn);
	if(ret)
	{
		ZeroMemory(Path,256);
		strncpy(Path, pszBuffer, strlen(pszBuffer) - strlen(FileName) );
//		MessageBox(hWnd,Path,"DEBUG",MB_OK);
		WritePrivateProfileString("Path",pszDefExt, Path ,szIniFileName);
	}
	delete [] Path;
	delete [] szIniFileName;
	return ret;
}

// Restore character
BOOL RestoreChar()
{
	short Slot;
	if(!GetDiabloProcID())
		return DisableDlg();
	Slot = Refresh();
	if(Slot==-1)
		return MessageBox(hMainDlg,"Unavailable Slot","Error",MB_OK | MB_ICONERROR);
	char szFileName[256];
	memset(szFileName,0,256);
	if (!GetFileName(hMainDlg, szFileName, sizeof(szFileName),
		"Diablo Character files (*.cha)\0*.cha\0All Files (*.*)\0*.*\0",
		"cha", FALSE))
		return TRUE;
	char Header[21];
	Header[20]=0;
	ifstream charfile;
	charfile.open(szFileName,ios::in|ios::binary);
	charfile.seekg(0);
	charfile.read(Header,20);
	if(strcmp(Header,CHAHEADER))
	{	
		MessageBox(hMainDlg,"Invalid Character format","Error",MB_ICONERROR | MB_OK);
		charfile.close();
		return TRUE;
	}
	char *pCharacter = new char[21044];
	charfile.read(pCharacter,21044);
	charfile.close();
	WriteProcessMemory(hDiablo,(void*)(CHAROFFSET+Slot*21720),pCharacter,21044,NULL);
	delete [] pCharacter;
	Refresh();
	MessageBox(hMainDlg,"Character restored!","Done",MB_OK);
	return TRUE;
}

BOOL GetDiabloProcID()
{
	DWORD dwDiabloProcId;
	HWND hTempDiabloWnd;
	hTempDiabloWnd = FindWindow("DIABLO", "DIABLO");
	if(!hTempDiabloWnd)
	{
//		MessageBox(NULL, "Error Finding Diablo Process ID.","Error!",MB_OK | MB_ICONERROR);
		hDiablo=NULL;
		return FALSE;
	}
	if(hTempDiabloWnd==hDiabloWnd)
		if(hDiablo)
			return TRUE;
	hDiabloWnd=hTempDiabloWnd;
	GetWindowThreadProcessId(hDiabloWnd, &dwDiabloProcId);
	hDiablo = OpenProcess(PROCESS_ALL_ACCESS, FALSE, dwDiabloProcId);
	if (!hDiablo)
	{
		MessageBox(hMainDlg, "Cannot Access Diablo!","Error!",MB_OK | MB_ICONERROR);
		return FALSE;
	}
	char Version[51];
	Version[50]=0;
	ReadProcessMemory(hDiablo,(const void*)(VERSTR_7),Version,50,NULL);
	if(!strcmp(DIABLOVERSION_7,Version))
	{
		GROUND = GROUND_7;
		VERSTR = VERSTR_7;
		CHARSLOT = CHARSLOT_7;
		CHAROFFSET = CHAROFFSET_7;
		NAMEOFFSET = NAMEOFFSET_7;
		strcpy(DIABLOVERSION, DIABLOVERSION_7);
		return TRUE;
	}
	ReadProcessMemory(hDiablo,(const void*)(VERSTR_8),Version,50,NULL);
	if(!strcmp(DIABLOVERSION_8,Version))
	{
		GROUND = GROUND_8;
		VERSTR = VERSTR_8;
		CHARSLOT = CHARSLOT_8;
		CHAROFFSET = CHAROFFSET_8;
		NAMEOFFSET = NAMEOFFSET_8;
		strcpy(DIABLOVERSION, DIABLOVERSION_8);
		return TRUE;
	}
	ReadProcessMemory(hDiablo,(const void*)(VERSTR_9),Version,50,NULL);
	if(!strcmp(DIABLOVERSION_9, Version))
	{
		GROUND = GROUND_9;
		VERSTR = VERSTR_9;
		CHARSLOT = CHARSLOT_9;
		CHAROFFSET = CHAROFFSET_9;
		NAMEOFFSET = NAMEOFFSET_9;
		strcpy(DIABLOVERSION, DIABLOVERSION_9);
		return TRUE;
	}
	return DialogBox(hInstance, MAKEINTRESOURCE(IDD_COMPATIBLE), hMainDlg, (DLGPROC)CompDlgProc);
	hDiablo = NULL;
}

short Refresh()
{
	int YourSlot;
	ShowWindow(GetDlgItem(hMainDlg,IDC_DOOMGAZE),SW_HIDE);
	ShowWindow(GetDlgItem(hMainDlg,IDC_HIDDEN),SW_HIDE);
	ShowWindow(GetDlgItem(hMainDlg,IDC_IGNOREVERSION),SW_HIDE);
	ShowWindow(GetDlgItem(hMainDlg,IDC_PLAYERSFRM),SW_SHOW);
	ShowWindow(GetDlgItem(hMainDlg,IDC_NOIDFRM),SW_HIDE);
	ShowWindow(GetDlgItem(hMainDlg,IDC_PLAYER1),SW_SHOW);
	ShowWindow(GetDlgItem(hMainDlg,IDC_PLAYER2),SW_SHOW);
	ShowWindow(GetDlgItem(hMainDlg,IDC_PLAYER3),SW_SHOW);
	ShowWindow(GetDlgItem(hMainDlg,IDC_PLAYER4),SW_SHOW);
	char szPlayerName[25];
	EnableWindow(GetDlgItem(hMainDlg,IDC_EDITBUTTON),TRUE);
	EnableWindow(GetDlgItem(hMainDlg,IDC_HACKS),TRUE);
	EnableWindow(GetDlgItem(hMainDlg,IDC_SWITCHEM),TRUE);
	EnableWindow(GetDlgItem(hMainDlg,IDC_GROUNDED),TRUE);
	EnableWindow(GetDlgItem(hMainDlg,IDC_SAVEBUTTON),TRUE);
	EnableWindow(GetDlgItem(hMainDlg,IDC_RESTOREBUTTON),TRUE);
	//CheckRadioButton(hDlg,IDC_PLAYER1,IDC_PLAYER4,IDC_PLAYER1);

	if(g_pTempChar)
	{
		ReadProcessMemory(hDiablo,(void*)(CHARSLOT),(void*)&YourSlot,4,NULL);
		WriteProcessMemory(hDiablo,(void*)(CHAROFFSET+YourSlot*21720),g_pTempChar,21044,NULL);
		delete [] g_pTempChar;
		g_pTempChar = NULL;
	}
	


	ReadProcessMemory(hDiablo,(const void*)NAMEOFFSET,szPlayerName,25,NULL);
	SetDlgItemText(hMainDlg,IDC_PLAYER1,szPlayerName);
	EnableWindow(GetDlgItem(hMainDlg,IDC_PLAYER1),szPlayerName[0]);
	ReadProcessMemory(hDiablo,(const void*)(NAMEOFFSET+21720),szPlayerName,25,NULL);
	SetDlgItemText(hMainDlg,IDC_PLAYER2,szPlayerName);
	EnableWindow(GetDlgItem(hMainDlg,IDC_PLAYER2),szPlayerName[0]);
	ReadProcessMemory(hDiablo,(const void*)(NAMEOFFSET+21720*2),szPlayerName,25,NULL);
	SetDlgItemText(hMainDlg,IDC_PLAYER3,szPlayerName);
	EnableWindow(GetDlgItem(hMainDlg,IDC_PLAYER3),szPlayerName[0]);
	ReadProcessMemory(hDiablo,(const void*)(NAMEOFFSET+21720*3),szPlayerName,25,NULL);
	SetDlgItemText(hMainDlg,IDC_PLAYER4,szPlayerName);
	EnableWindow(GetDlgItem(hMainDlg,IDC_PLAYER4),szPlayerName[0]);
	if ((IsDlgButtonChecked(hMainDlg,IDC_PLAYER1)==BST_CHECKED) && (IsWindowEnabled(GetDlgItem(hMainDlg,IDC_PLAYER1))))
      return 0;
	if ((IsDlgButtonChecked(hMainDlg,IDC_PLAYER2)==BST_CHECKED) && (IsWindowEnabled(GetDlgItem(hMainDlg,IDC_PLAYER2))))
      return 1;
	if ((IsDlgButtonChecked(hMainDlg,IDC_PLAYER3)==BST_CHECKED) && (IsWindowEnabled(GetDlgItem(hMainDlg,IDC_PLAYER3))))
      return 2;
	if ((IsDlgButtonChecked(hMainDlg,IDC_PLAYER4)==BST_CHECKED) && (IsWindowEnabled(GetDlgItem(hMainDlg,IDC_PLAYER4))))
      return 3;
	return -1;
} 
 
BOOL DisableDlg()
{
	EnableWindow(GetDlgItem(hMainDlg,IDC_EDITBUTTON),FALSE);
	EnableWindow(GetDlgItem(hMainDlg,IDC_SWITCHEM),FALSE);
	EnableWindow(GetDlgItem(hMainDlg,IDC_GROUNDED),FALSE);
	EnableWindow(GetDlgItem(hMainDlg,IDC_HACKS),FALSE);	
	EnableWindow(GetDlgItem(hMainDlg,IDC_SAVEBUTTON),FALSE);
	EnableWindow(GetDlgItem(hMainDlg,IDC_RESTOREBUTTON),FALSE);
	ShowWindow(GetDlgItem(hMainDlg,IDC_NOIDFRM),SW_SHOW);
	ShowWindow(GetDlgItem(hMainDlg,IDC_HIDDEN),SW_SHOW);
	ShowWindow(GetDlgItem(hMainDlg,IDC_IGNOREVERSION),SW_SHOW);
	ShowWindow(GetDlgItem(hMainDlg,IDC_PLAYERSFRM),SW_HIDE);
	ShowWindow(GetDlgItem(hMainDlg,IDC_PLAYER1),SW_HIDE);
	ShowWindow(GetDlgItem(hMainDlg,IDC_PLAYER2),SW_HIDE);
	ShowWindow(GetDlgItem(hMainDlg,IDC_PLAYER3),SW_HIDE);
	ShowWindow(GetDlgItem(hMainDlg,IDC_PLAYER4),SW_HIDE);
	ShowWindow(GetDlgItem(hMainDlg,IDC_DOOMGAZE),SW_SHOW);
	return TRUE;
}

BOOL SaveChar()
{
	char szFileName[256];
	short Slot;
	if(!GetDiabloProcID())
		return DisableDlg();
	Slot = Refresh();
	memset(szFileName,0,256);
	if(Slot==-1)
		return MessageBox(hMainDlg,"Unavailable Slot","Error",MB_OK | MB_ICONERROR);
	ReadProcessMemory(hDiablo,(const void*)(NAMEOFFSET+21720*Slot),szFileName,25,NULL);
	for(short temp=0;temp<25;temp++)
	{
		switch(szFileName[temp])
		{
			case '\\':
			case '/':
			case ':':
			case '*':
			case '?':
			case '"':
			case '<':
			case '>':
			case '|':
				szFileName[temp]='_';
		}
	}
	if (!GetFileName(hMainDlg, szFileName, sizeof(szFileName),
		"Diablo Character files (*.cha)\0*.cha\0All Files (*.*)\0*.*\0",
		"cha", TRUE))
		return TRUE;
	char *pCharacter = new char[21044];
	ReadProcessMemory(hDiablo,(void*)(CHAROFFSET+Slot*21720),pCharacter,21044,NULL);
	ofstream charfile;
	charfile.open(szFileName,ios::out|ios::binary|ios::trunc);
	charfile.seekp(0);
	charfile.write(CHAHEADER,20);
	charfile.write(pCharacter,21044);
	charfile.close();
	delete [] pCharacter;
	MessageBox(hMainDlg,"Character saved!","Done",MB_OK);
	return TRUE;
}

BOOL WINAPI AboutDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static UINT i;
	static HICON Icons[6];
	switch (msg)
	{
		case WM_INITDIALOG:
			i = 0;
			hAboutDlg = hDlg;
			SetDlgItemText(hDlg, IDC_RELVERSION, RELVERSION);
			SetDlgItemText(hDlg, IDC_RELDATE, RELDATE);
			SetDlgItemText(hDlg, IDC_RELTEXT, RELTEXT);
			Icons[0] = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ANIM1));
			Icons[1] = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ANIM2));
			Icons[2] = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ANIM3));
			Icons[3] = Icons[1];
			Icons[4] = Icons[0];
			Icons[5] = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_DIABLO));
			SetTimer(hAboutDlg, TIMER_ICON, 50, (TIMERPROC) NULL);
			i =0;
			return TRUE;

		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDC_BLINK:
				case IDC_DIABLOICON:
					if(STN_CLICKED==HIWORD(wParam))
					{
						SetTimer(hAboutDlg, TIMER_ICON, 50, (TIMERPROC) NULL);
						i =0;
					}
					return TRUE;
			
				case IDCANCEL:
               EndDialog(hAboutDlg,TRUE);
         		return TRUE;
				default:
					return FALSE;
			}

		case WM_TIMER:
			SendDlgItemMessage(hDlg,
				IDC_DIABLOICON,
				STM_SETIMAGE,
				(WPARAM) IMAGE_ICON,
				(LPARAM) Icons[i]);
			i++;
			if(i == 6)
			{
				i = 0;
				KillTimer(hDlg, TIMER_ICON);
			}
			return TRUE;
		case WM_DESTROY:
			if(i)
				KillTimer(hAboutDlg, TIMER_ICON);
			return TRUE;

			
	}
	return FALSE;
}

BOOL WINAPI EditDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
static _CharStruct *pCharacter;
static short Slot;
int index, temp;
	switch(msg)
	{
		case WM_INITDIALOG:
			hEditDlg=hDlg;
			Slot = (short) lParam;
			HICON hDiabloIcon;
			hDiabloIcon = LoadIcon(hInstance,MAKEINTRESOURCE(IDI_DIABLO));
			SendMessage(hDlg, WM_SETICON, (WPARAM) ICON_BIG | ICON_SMALL , (LPARAM) (HICON) hDiabloIcon);
			pCharacter = new _CharStruct;
			memset(pCharacter,0,21044);
			if(Slot==100)
			{
				SetDlgItemText(hDlg,IDOK,"Save");
				SetDlgItemText(hDlg,IDCANCEL,"Quit");

				pCharacter = g_pCharacter;
			}
			else
				ReadProcessMemory(hDiablo,(void*)(CHAROFFSET+Slot*21720),pCharacter,21044,NULL);
			//EnableWindow(GetDlgItem(hEditDlg,IDC_EDITITEMBUTTON),FALSE);
			//EnableWindow(GetDlgItem(hEditDlg,IDC_EXPORTBUTTON),FALSE);
			//EnableWindow(GetDlgItem(hEditDlg,IDC_IMPORTBUTTON),FALSE);
			//EnableWindow(GetDlgItem(hEditDlg,IDC_DELETEBUTTON),FALSE);
			SetDlgItemText(hDlg,IDC_EDITCHARNAME,pCharacter->CharName);
			SendDlgItemMessage(hDlg,IDC_EDITCHARNAME,EM_LIMITTEXT,15,NULL);
			SetDlgItemInt(hDlg,IDC_CHARLEVEL,(unsigned int) pCharacter->Level,FALSE);
			SetDlgItemInt(hDlg,IDC_CHARSTR,pCharacter->StrBase,FALSE);
			SetDlgItemInt(hDlg,IDC_CHARMAG,pCharacter->MagBase,FALSE);
			SetDlgItemInt(hDlg,IDC_CHARDEX,pCharacter->DexBase,FALSE);
			SetDlgItemInt(hDlg,IDC_CHARVIT,pCharacter->VitBase,FALSE);

			SetDlgItemInt(hDlg,IDC_CHARSTRNOW,pCharacter->StrNow,FALSE);
			SetDlgItemInt(hDlg,IDC_CHARMAGNOW,pCharacter->MagNow,FALSE);
			SetDlgItemInt(hDlg,IDC_CHARDEXNOW,pCharacter->DexNow,FALSE);
			SetDlgItemInt(hDlg,IDC_CHARVITNOW,pCharacter->VitNow,FALSE);

			SetDlgItemInt(hDlg,IDC_CHARHP,pCharacter->MaxHealthBase/64,FALSE);
			SetDlgItemInt(hDlg,IDC_CHARMP,pCharacter->MaxManaBase/64,FALSE);
			
			SetDlgItemInt(hDlg,IDC_CHARHPNOW,pCharacter->MaxHealthNow/64,FALSE);
			SetDlgItemInt(hDlg,IDC_CHARMPNOW,pCharacter->MaxManaNow/64,FALSE);
			
			SetDlgItemInt(hDlg,IDC_POINTS,pCharacter->PointsToDistrib,FALSE);
			
			for(index=0;index<7;index++)
			{
				if(pCharacter->EquItems[index].EncodedType==-1)
					SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_ADDSTRING, 0 ,(LPARAM) "Empty");
				else
					SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_ADDSTRING, 0 ,(LPARAM) (char *) pCharacter->EquItems[index].IDedName);
			}	
			for(index=0;index<40;index++)
			{
				temp = pCharacter->ItemPos[index];
				if(temp<1)
					SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_ADDSTRING, 0 ,(LPARAM) "Empty");
				else
				{
					if(pCharacter->InvItems[temp-1].IDFlag)
						SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_ADDSTRING, 0 ,(LPARAM) (char *) pCharacter->InvItems[temp-1].IDedName);
					else
						SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_ADDSTRING, 0 ,(LPARAM) (char *) pCharacter->InvItems[temp-1].UnIDName);
				}
			}	
			SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_SETCURSEL, 0, 0);
			SendDlgItemMessage(hEditDlg, IDC_CLASSES, CB_ADDSTRING, 0, (LPARAM)"Warrior");
			SendDlgItemMessage(hEditDlg, IDC_CLASSES, CB_ADDSTRING, 0, (LPARAM)"Rogue");
			SendDlgItemMessage(hEditDlg, IDC_CLASSES, CB_ADDSTRING, 0, (LPARAM)"Sorcerer");
			SendDlgItemMessage(hEditDlg, IDC_CLASSES, CB_SETCURSEL, pCharacter->CharClass, 0);
			
			for(index=0;index<36;index++)
				SendDlgItemMessage(hEditDlg, IDC_SPELLSLIST, LB_ADDSTRING, 0, (LPARAM) theSpells[index]);

			SendDlgItemMessage(hEditDlg, IDC_SPELLSLIST, LB_SETCURSEL, 0, 0);
			SetDlgItemInt(hEditDlg, IDC_SPELLLEVEL, pCharacter->SpellLevels[0], FALSE);
			if(pCharacter->SpellsFlags1&1)
				CheckDlgButton(hEditDlg, IDC_SPELLSELECT, BST_CHECKED);
			else
				CheckDlgButton(hEditDlg, IDC_SPELLSELECT, BST_UNCHECKED);
			if(pCharacter->SkillsFlags1&1)
				CheckDlgButton(hEditDlg, IDC_SKILLSELECT, BST_CHECKED);
			else
				CheckDlgButton(hEditDlg, IDC_SKILLSELECT, BST_UNCHECKED);
			return TRUE;
		
		case WM_DESTROY:
			delete pCharacter;
			g_pCharacter = NULL;

			return TRUE;
			
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDC_DELETEBUTTON:
					index = SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_GETCURSEL, 0, 0);
					return DeleteItem(index,pCharacter);
													
				case IDC_IMPORTBUTTON:
					index = SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_GETCURSEL, 0, 0);
					return ImportItem(index,pCharacter);

				case IDC_EXPORTBUTTON:
					index = SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_GETCURSEL, 0, 0);
					return ExportItem(index,pCharacter);
			
				case IDC_EDITITEMBUTTON:
					index = SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_GETCURSEL, 0, 0);
					EditItem(index,pCharacter);
					return TRUE;

										
				case IDC_EXPBUTTON:
					pCharacter->ExpPoints = pCharacter->ExpForNextLevel;
					SetDlgItemText(hEditDlg,IDC_EXPBUTTON,"Done");
					EnableWindow(GetDlgItem(hEditDlg,IDC_EXPBUTTON),FALSE);


					return TRUE;

				case IDC_SPELLSLIST:
					if(HIWORD(wParam) == LBN_SELCHANGE)
					{
						index = SendDlgItemMessage(hEditDlg, IDC_SPELLSLIST, LB_GETCURSEL, 0, 0);
						SetDlgItemInt(hEditDlg, IDC_SPELLLEVEL, pCharacter->SpellLevels[index], FALSE);
						if(index<32)
						{
							if(pCharacter->SpellsFlags1 &(1<<index))
								CheckDlgButton(hEditDlg, IDC_SPELLSELECT, BST_CHECKED);
							else
								CheckDlgButton(hEditDlg, IDC_SPELLSELECT, BST_UNCHECKED);
							if(pCharacter->SkillsFlags1 &(1<<index))
								CheckDlgButton(hEditDlg, IDC_SKILLSELECT, BST_CHECKED);
							else
								CheckDlgButton(hEditDlg, IDC_SKILLSELECT, BST_UNCHECKED);
						}
						else
						{
							if(pCharacter->SpellsFlags2 &(1<<(index-32)))
								CheckDlgButton(hEditDlg, IDC_SPELLSELECT, BST_CHECKED);
							else
								CheckDlgButton(hEditDlg, IDC_SPELLSELECT, BST_UNCHECKED);
							if(pCharacter->SkillsFlags2 &(1<<(index-32)))
								CheckDlgButton(hEditDlg, IDC_SKILLSELECT, BST_CHECKED);
							else
								CheckDlgButton(hEditDlg, IDC_SKILLSELECT, BST_UNCHECKED);
						}
					}
					return TRUE;
				
				
				case IDC_SPELLSELECT:
					if(HIWORD(wParam) == BN_CLICKED)
					{
						index = SendDlgItemMessage(hEditDlg, IDC_SPELLSLIST, LB_GETCURSEL, 0, 0);
						if(index<32)
							pCharacter->SpellsFlags1 = pCharacter->SpellsFlags1^(1<<index);
						else
							pCharacter->SpellsFlags2 = pCharacter->SpellsFlags2^(1<<(index-32));
					}
					return TRUE;			

				case IDC_SKILLSELECT:
					if(HIWORD(wParam) == BN_CLICKED)
					{
						index = SendDlgItemMessage(hEditDlg, IDC_SPELLSLIST, LB_GETCURSEL, 0, 0);
						if(index<32)
							pCharacter->SkillsFlags1 = pCharacter->SkillsFlags1^(1<<index);
						else
							pCharacter->SkillsFlags2 = pCharacter->SkillsFlags2^(1<<(index-32));
					}
					return TRUE;			

					
				case IDC_SPELLLEVEL:
					if(HIWORD(wParam) == EN_UPDATE)
					{
						index = SendDlgItemMessage(hEditDlg, IDC_SPELLSLIST, LB_GETCURSEL, 0, 0);
						pCharacter->SpellLevels[index] = GetDlgItemInt(hEditDlg, IDC_SPELLLEVEL,NULL,FALSE);
					}
					return TRUE;			
				
				case IDOK:
					unsigned int temp;
					temp = GetDlgItemInt(hDlg,IDC_CHARLEVEL,NULL,FALSE);
					if(temp>50)
						return MessageBox(hEditDlg,"Level can't exceed 50","Error",MB_OK | MB_ICONERROR);
					pCharacter->Level = (unsigned char) temp;
					pCharacter->MaxHealthBase = GetDlgItemInt(hEditDlg,IDC_CHARHP,NULL,FALSE)*64;
					if(pCharacter->MaxHealthBase < pCharacter->CurHealthBase) pCharacter->CurHealthBase = pCharacter->MaxHealthBase;
					pCharacter->MaxManaBase = GetDlgItemInt(hEditDlg,IDC_CHARMP,NULL,FALSE)*64;
					if(pCharacter->MaxManaBase < pCharacter->CurManaBase) pCharacter->CurManaBase = pCharacter->MaxManaBase;
					pCharacter->StrBase = GetDlgItemInt(hDlg,IDC_CHARSTR,NULL,FALSE);
					pCharacter->MagBase = GetDlgItemInt(hDlg,IDC_CHARMAG,NULL,FALSE);
					pCharacter->DexBase = GetDlgItemInt(hDlg,IDC_CHARDEX,NULL,FALSE);
					pCharacter->VitBase = GetDlgItemInt(hDlg,IDC_CHARVIT,NULL,FALSE);
					pCharacter->PointsToDistrib = GetDlgItemInt(hDlg,IDC_POINTS,NULL,FALSE);
					pCharacter->CharClass = SendDlgItemMessage(hEditDlg, IDC_CLASSES, CB_GETCURSEL, 0, 0);
					
					GetDlgItemText(hEditDlg,IDC_EDITCHARNAME,pCharacter->CharName, 16);
					if(Slot==100)
						WriteCharFile();
					else
						WriteProcessMemory(hDiablo,(void*)(CHAROFFSET+Slot*21720),pCharacter,21044,NULL);
// quit
				case IDCANCEL:
					EndDialog(hDlg,FALSE);
         		return TRUE;
				default:
					return FALSE;
			}
		default:
			return FALSE;
	}
}

BOOL ImportItem(int index,_CharStruct *pCharacter)
{
	char szFileName[256];
	memset(szFileName,0,256);
	if (!GetFileName(hEditDlg, szFileName, sizeof(szFileName),
		"Diablo Item files (*.itm)\0*.itm\0All Files (*.*)\0*.*\0",
		"itm", FALSE))
		return TRUE;
	char Header[32];
	Header[31]=0;
	ifstream itemfile;
	itemfile.open(szFileName,ios::in|ios::binary);
	itemfile.seekg(0);
	itemfile.read(Header,32);
	if(strcmp(Header,ITMHEADER))
	{	
		MessageBox(hMainDlg,"Invalid Item format","Error",MB_ICONERROR | MB_OK);
		itemfile.close();
		return TRUE;
	}
	if(index<7)
	{
		itemfile.read((char *) &pCharacter->EquItems[index],368);
		itemfile.close();
		SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_DELETESTRING, index, 0);
		if(pCharacter->EquItems[index].IDFlag)
			SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_INSERTSTRING, index, (LPARAM) pCharacter->EquItems[index].IDedName);
		else
			SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_INSERTSTRING, index, (LPARAM) pCharacter->EquItems[index].UnIDName);
		SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_SETCURSEL, index, 0);
	   return TRUE;
	}
	int Pos;

	Pos = pCharacter->ItemPos[index-7];
	if(Pos<1)
	{
		pCharacter->NumbOfItems++;
		for(Pos=1;;Pos++)
			if(CheckPosition(Pos,(char *) &pCharacter->ItemPos[0]))
				break;
		pCharacter->ItemPos[index-7] = Pos;
// damn i really wish i had put more comments in
	}
	Pos--;				
	itemfile.read((char *) &pCharacter->InvItems[Pos],368);
	SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_DELETESTRING, index, 0);
	if(pCharacter->InvItems[Pos].IDFlag)
		SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_INSERTSTRING, index, (LPARAM) pCharacter->InvItems[Pos].IDedName);
	else
		SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_INSERTSTRING, index, (LPARAM) pCharacter->InvItems[Pos].UnIDName);
	SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_SETCURSEL, index, 0);
	return TRUE;
	
	
	//MessageBox(hMainDlg,"Item Imported!","Done",MB_OK);
	return TRUE;
}
	
BOOL ExportItem(int index,_CharStruct *pCharacter)
{
	if(index<7)
		if(pCharacter->EquItems[index].EncodedType==-1)
			return MessageBox(NULL, "Nothing to Export.","Error!",MB_OK | MB_ICONERROR);

	if(index>6)
		if(pCharacter->ItemPos[index-7]<1)
			return MessageBox(NULL, "Nothing to Export.","Error!",MB_OK | MB_ICONERROR);
	short temp;
	char szFileName[256];
	memset(szFileName,0,256);
	if(index<7)
		strcpy(szFileName, pCharacter->EquItems[index].IDedName);
	if(index>6)
	{
		temp=pCharacter->ItemPos[index -7];
		temp--;
		strcpy(szFileName, pCharacter->InvItems[temp].IDedName);
	}
	for(temp=0;temp<64;temp++)
	{
		switch(szFileName[temp])
		{
			case '\\':
			case '/':
			case ':':
			case '*':
			case '?':
			case '"':
			case '<':
			case '>':
			case '|':
				szFileName[temp]='_';
		}
	}	
	if (!GetFileName(hEditDlg, szFileName, sizeof(szFileName),
		"Diablo Item files (*.itm)\0*.itm\0All Files (*.*)\0*.*\0",
		"itm", TRUE))
		return TRUE;
	
/*	char ItemHeader[32] = {
		0x49, 0x54, 0x4D, 0x30, 0x31, 0x2E, 0x49, 0x27, 0x6C, 0x6C, 0x20, 0x67, 0x65, 0x74, 0x20, 0x74, 
		0x68, 0x61, 0x74, 0x20, 0x61, 0x6C, 0x27, 0x54, 0x68, 0x6F, 0x72, 0x21, 0x00, 0x00, 0x00, 0x00, 
		};
*/
	ofstream itemfile;
	itemfile.open(szFileName,ios::out|ios::binary|ios::trunc);
	itemfile.seekp(0);
	itemfile.write(ITMHEADER,32);
	if(index<7)
		itemfile.write(pCharacter->EquItems[index].UniqueItemNumber,368);
	if(index>6)
	{
		temp=pCharacter->ItemPos[index -7];
		temp--;
		itemfile.write(pCharacter->InvItems[temp].UniqueItemNumber,368);
	}
	itemfile.close();
	MessageBox(hMainDlg,"Item Exported!","Done",MB_OK);
	return TRUE;
}

BOOL DeleteItem(int index,_CharStruct *pCharacter)
{
	if(index<7)
	{
		if(pCharacter->EquItems[index].EncodedType==-1)
			return MessageBox(NULL, "Nothing to Delete.","Error!",MB_OK | MB_ICONERROR);
		memset(pCharacter->EquItems[index].UniqueItemNumber,0,368);
		pCharacter->EquItems[index].EncodedType=-1;
		SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_DELETESTRING, index, 0);
		SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_INSERTSTRING, index, (LPARAM) "Empty");
		SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_SETCURSEL, index, 0);
		return TRUE;
	}
	if(pCharacter->ItemPos[index-7]<1)
		return MessageBox(NULL, "Nothing to Delete.","Error!",MB_OK | MB_ICONERROR);
	pCharacter->NumbOfItems--;
	pCharacter->ItemPos[index-7]=0;
	SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_DELETESTRING, index, 0);
	SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_INSERTSTRING, index, (LPARAM) "Empty");
	SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_SETCURSEL, index, 0);
	for(index=0;index<40;index++)
		if(pCharacter->ItemPos[index]<1)
			pCharacter->ItemPos[index]=0;
	return TRUE;
}

int AllocPos(char *ItemPos)
{
	int Pos,index;
	for(Pos=0;;Pos++)
		if(ItemPos[Pos]<1)
			break;
	index = Pos;
	for(Pos=1;;Pos++)
		if(CheckPosition(Pos,(char *) &ItemPos[0]))
			break;
	ItemPos[index] = Pos;
	Pos--;
	return Pos;
}

BOOL OpenCharFile()
{
	char Header[21];
	Header[20]=0;
	ifstream charfile;
	charfile.open(g_CmdLine,ios::in|ios::binary);
	charfile.seekg(0);
	charfile.read(Header,20);
	if(strcmp(Header,CHAHEADER))
	{	
		MessageBox(NULL,"Invalid Character format","Error",MB_ICONERROR | MB_OK);
		charfile.close();
		return FALSE;
	}
	g_pCharacter = new _CharStruct;
	charfile.read((char *) g_pCharacter,21044);
	charfile.close();
	return TRUE;
}

BOOL WriteCharFile()
{
	ofstream charfile;
	charfile.open(g_CmdLine,ios::out|ios::binary|ios::trunc);
	charfile.seekp(0);
	charfile.write(CHAHEADER,20);
	charfile.write((char *) g_pCharacter,21044);
	charfile.close();
	MessageBox(hEditDlg,"Character saved!","Done",MB_OK);
	return TRUE;
}


BOOL RegisterFileType(const char *szFileExt, const char *szFileType, const char *szFileDesc, int nIcon)
{
	char szModuleFileName[256];
	char szBuffer[256];
	HKEY hk;
	DWORD dwDisp;
	DWORD dwBufferSize;
	DWORD dwBufferType;

	GetModuleFileName(hInstance, szModuleFileName, 255);
//	MessageBox(NULL,szModuleFileName,"ModuleFileName",MB_OK);

	if(!RegCreateKeyEx(HKEY_CLASSES_ROOT,
		szFileExt,0,NULL,
		REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL,
		&hk, &dwDisp)==ERROR_SUCCESS)
		return FALSE;
	dwBufferType=REG_SZ;
	dwBufferSize=strlen(szFileType)+1;
	if(!RegSetValueEx(hk,"",0, dwBufferType,
		(LPBYTE)szFileType, dwBufferSize)==ERROR_SUCCESS)
		return FALSE;
	RegCloseKey(hk);

	if(!RegCreateKeyEx(HKEY_CLASSES_ROOT,
		szFileType,0,NULL,
		REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL,
		&hk, &dwDisp)==ERROR_SUCCESS)
		return FALSE;
	dwBufferType=REG_SZ;
	dwBufferSize=strlen(szFileDesc)+1;
	if(!RegSetValueEx(hk,"",0, dwBufferType,
		(LPBYTE)szFileDesc, dwBufferSize)==ERROR_SUCCESS)
		return FALSE;
	RegCloseKey(hk);

	wsprintf(szBuffer,"%s\\DefaultIcon",szFileType);
	//MessageBox(NULL,szBuffer,"testing",MB_OK);

	if(!RegCreateKeyEx(HKEY_CLASSES_ROOT,
		szBuffer,0,NULL,
		REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL,
		&hk, &dwDisp)==ERROR_SUCCESS)
		return FALSE;
	wsprintf(szBuffer,"%s,%i",szModuleFileName, nIcon);
	//MessageBox(NULL,szBuffer,"testing",MB_OK);
	dwBufferType=REG_SZ;
	dwBufferSize=strlen(szBuffer)+1;
		
	if(!RegSetValueEx(hk,"",0, dwBufferType,
		(LPBYTE)szBuffer, dwBufferSize)==ERROR_SUCCESS)
		return FALSE;
	RegCloseKey(hk);
	
	wsprintf(szBuffer,"%s\\shell\\open\\command",szFileType);
	//MessageBox(NULL,szBuffer,"testing",MB_OK);

	if(!RegCreateKeyEx(HKEY_CLASSES_ROOT,
		szBuffer,0,NULL,
		REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL,
		&hk, &dwDisp)==ERROR_SUCCESS)
		return FALSE;
	wsprintf(szBuffer,"%s %%1",szModuleFileName);
	//MessageBox(NULL,szBuffer,"testing",MB_OK);
	dwBufferType=REG_SZ;
	dwBufferSize=strlen(szBuffer)+1;
		
	if(!RegSetValueEx(hk,"",0, dwBufferType,
		(LPBYTE)szBuffer, dwBufferSize)==ERROR_SUCCESS)
		return FALSE;
	RegCloseKey(hk);

	
	wsprintf(szBuffer,"%s\\shell\\edit\\command",szFileType);

	if(!strcmp(szFileExt,".dat"))
	{
		if(!RegCreateKeyEx(HKEY_CLASSES_ROOT,
			szBuffer,0,NULL,
			REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL,
			&hk, &dwDisp)==ERROR_SUCCESS)
			return FALSE;
		if(!RegSetValueEx(hk,"",0, REG_SZ,
			(LPBYTE)"notepad %1", strlen("notepad %1")+1)==ERROR_SUCCESS)
			return FALSE;
		RegCloseKey(hk);
	}
	
	return TRUE;

}

BOOL OpenItemFile()
{
	char Header[32];
	ifstream itemfile;
	itemfile.open(g_CmdLine,ios::in|ios::binary);
	itemfile.seekg(0);
	itemfile.read(Header,32);
	if(strcmp(Header,ITMHEADER))
	{	
		MessageBox(NULL,"Invalid Item format","Error",MB_ICONERROR | MB_OK);
		itemfile.close();
		return FALSE;
	}
	g_pItem = new _ItemStruct;
	itemfile.read((char *) g_pItem,368);
	itemfile.close();
	return TRUE;
}

BOOL WriteItemFile()
{
	ofstream itemfile;
	itemfile.open(g_CmdLine,ios::out|ios::binary|ios::trunc);
	itemfile.seekp(0);
	itemfile.write(ITMHEADER,32);
	itemfile.write((char *) g_pItem,368);
	itemfile.close();
	delete [] g_pItem;
	MessageBox(NULL,"Item saved!","Done",MB_OK);
	return TRUE;
}

BOOL WINAPI ItemDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	LPNMHDR notify;
	int selection = 0;
	static HWND hChild = NULL;
	static _ItemStruct *pNewItem;

	switch(msg)
	{
		case WM_INITDIALOG:
			hItemDlg = hDlg;
			HICON hDiabloIcon;
			hDiabloIcon = LoadIcon(hInstance,MAKEINTRESOURCE(IDI_DIABLO));
			SendMessage(hDlg, WM_SETICON, (WPARAM) ICON_BIG | ICON_SMALL , (LPARAM) (HICON) hDiabloIcon);
			
			TabInsert(GetDlgItem(hDlg, IDC_ITEM_TAB), 0, "General");
			TabInsert(GetDlgItem(hDlg, IDC_ITEM_TAB), 1, "Flags 1");
			TabInsert(GetDlgItem(hDlg, IDC_ITEM_TAB), 2, "Flags 2");
			pNewItem = new _ItemStruct;
			memcpy(pNewItem,g_pItem,sizeof(_ItemStruct));
			selection = 0;
			hChild = CreateDialogParam(hInstance, MAKEINTRESOURCE(IDD_ITEM_TAB0), hDlg, (FARPROC) ItemTab0Proc,(LPARAM) pNewItem);

			return TRUE;

		case WM_DESTROY:
			delete pNewItem;
			return TRUE;


		case WM_NOTIFY:
			notify = (LPNMHDR) lParam;
			if(	notify->code == TCN_SELCHANGE )
			{
				DestroyWindow(hChild);
				selection = TabCtrl_GetCurSel(GetDlgItem(hDlg, IDC_ITEM_TAB));
				switch(selection)
				{
					case 0:	hChild = CreateDialogParam(hInstance, MAKEINTRESOURCE(IDD_ITEM_TAB0), hDlg, (FARPROC) ItemTab0Proc,(LPARAM) pNewItem); break;
					case 1:	hChild = CreateDialogParam(hInstance, MAKEINTRESOURCE(IDD_ITEM_TAB1), hDlg, (FARPROC) ItemTab1Proc,(LPARAM) pNewItem); break;
					case 2:	hChild = CreateDialogParam(hInstance, MAKEINTRESOURCE(IDD_ITEM_TAB2), hDlg, (FARPROC) ItemTab2Proc,(LPARAM) pNewItem); break;
				}
				return TRUE;
			}
			else return FALSE;
		
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDOK:
					DestroyWindow(hChild);
					memcpy(g_pItem, pNewItem,sizeof(_ItemStruct));
					EndDialog(hItemDlg, TRUE);
					return TRUE;
				case IDCANCEL:
					EndDialog(hItemDlg, FALSE);
					return TRUE;

				default:
					return FALSE;
			}
		default:
			return FALSE;
	}
}

BOOL EditItem(int index, _CharStruct *pCharacter)
{
	if(index<7)
		if(pCharacter->EquItems[index].EncodedType==-1)
			return MessageBox(hEditDlg,"Nothing to Edit","Error",MB_OK|MB_ICONERROR);
		else
			g_pItem = &pCharacter->EquItems[index];
	else
		if(pCharacter->ItemPos[index-7]<1)
			return MessageBox(hEditDlg,"Nothing to Edit","Error",MB_OK|MB_ICONERROR);
		else
			g_pItem = &pCharacter->InvItems[pCharacter->ItemPos[index-7]-1];
	if(!DialogBox(hInstance,MAKEINTRESOURCE(IDD_ITEMDLG),hEditDlg,(FARPROC)ItemDlgProc))
		return TRUE;
	SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_DELETESTRING, index, 0);
	if(index<7)
	{
		if(pCharacter->EquItems[index].IDFlag)
			SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_INSERTSTRING, index, (LPARAM) pCharacter->EquItems[index].IDedName);
		else
			SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_INSERTSTRING, index, (LPARAM) pCharacter->EquItems[index].UnIDName);
	}
	else
	{
		if(pCharacter->InvItems[pCharacter->ItemPos[index-7]-1].IDFlag)
			SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_INSERTSTRING, index, (LPARAM) pCharacter->InvItems[pCharacter->ItemPos[index-7]-1].IDedName);
		else
			SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_INSERTSTRING, index, (LPARAM) pCharacter->InvItems[pCharacter->ItemPos[index-7]-1].UnIDName);
	}
	SendDlgItemMessage(hEditDlg, IDC_ITEMSLIST, LB_SETCURSEL, index, 0);
	return TRUE;
}

BOOL WINAPI GrndDlgProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam)
{
int index;
static CListView *GrndList;
	switch(Msg)
	{
		
		case WM_INITDIALOG:
			hGrndItmDlg = hDlg;
			g_pItem = new _ItemStruct;
			GrndList = new CListView;
			GrndList->SetVars(hInstance,GetDlgItem(hDlg,IDC_GRNDLIST));
			GrndList->AddColumn("Items",0,153);
			GrndList->AttachImageList(IDB_ITEMTYPES);
			GrndDlgProc(hDlg,WM_COMMAND,IDC_REFRESH,NULL);
			return TRUE;


		case WM_DESTROY:
			delete GrndList;
			delete g_pItem;
			return TRUE;


		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDOK:
					g_pCharacter = new _CharStruct;
					int Slot;
					ReadProcessMemory(hDiablo,(void*)(CHARSLOT),&Slot,4,NULL);
					ReadProcessMemory(hDiablo,(void*)(CHAROFFSET+Slot*21720),g_pCharacter,21044,NULL);
					GrndList->ProcessSelected(PickUpItemProc);
					WriteProcessMemory(hDiablo,(void*)(CHAROFFSET+Slot*21720),g_pCharacter,21044,NULL);
					return TRUE;

				case IDCANCEL:
					EndDialog(hDlg, TRUE);
					return TRUE;

				case IDC_CLEAN:
					char *temp;
					temp = new char[368];
					memset(temp,0,368);
					for(index=0;index<128;index++)
						WriteProcessMemory(hDiablo,(void*)(GROUND+368*index),temp,368,NULL);
					delete [] temp;
					GrndDlgProc(hDlg,WM_COMMAND,IDC_REFRESH,NULL);
					return TRUE;

				case IDC_REFRESH:
					int ListCnt;
					GrndList->DeleteAllItems();
					for(ListCnt=index=0;index<128;index++)
					{
						ReadProcessMemory(hDiablo,(const void*)(GROUND+368*index),g_pItem,368,NULL);
						if(g_pItem->UnIDName[0])
							GrndList->AddItem(ListCnt,0,g_pItem->IDedName,g_pItem->ItemType,index);
						ListCnt++;
					}
					return TRUE;

				default:
					return FALSE;

			}

		default:
			return FALSE;
	}
}

void PickUpItemProc(LPARAM index)
{
	if(g_pCharacter->NumbOfItems<40)
	{
		int Position = AllocPos(&g_pCharacter->ItemPos[0]);
		ReadProcessMemory(hDiablo,(const void*)(GROUND+368*index),g_pItem,368,NULL);
		memcpy(&g_pCharacter->InvItems[Position],g_pItem,sizeof(_ItemStruct));
		//MessageBox(hGrndItmDlg,g_pItem->IDedName,"Debug",MB_OK);
		g_pCharacter->NumbOfItems++;
		//IntMessageBox(hGrndItmDlg,"Pickup=%d",g_pCharacter->NumbOfItems,"Debug",MB_OK);
	}
	//else
		//MessageBox(hGrndItmDlg,"OverFlow","Error",MB_OK);
}

void ActivateHacksProc(LPARAM pHack)
{
	CHack *theHack = (CHack*) pHack;
	COffset *theData=theHack->Data;
	while(theData)
	{
		WriteProcessMemory(hDiablo, (void*) theData->offset,
			theData->Active,
			theData->size,
			NULL);
		theData=theData->Next;
	}
}

void DeactivateHacksProc(LPARAM pHack)
{
	CHack *theHack = (CHack*) pHack;
	COffset *theData=theHack->Data;
	if(theData)
	{
		if(theData->InActive)
		{
			while(theData)
			{
				WriteProcessMemory(hDiablo, (void*) theData->offset,
					theData->InActive,
					theData->size,
					NULL);
				theData=theData->Next;
			}
		}
	}
}

BOOL CheckPosition(int Pos,char *ItemPos)
{
	int temp;
	for(temp=0;temp<40;temp++)
		if(ItemPos[temp]==Pos)
			return FALSE;
	return TRUE;
}

BOOL WINAPI HacksDlgProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	static CListView *HacksList;
	static CHack *F_HACK;
	static CHack *C_HACK;
	static index;
	H_STAT tStat;
	switch(Msg)
	{
		case WM_INITDIALOG:
			HICON hDiabloIcon;
			hDiabloIcon = LoadIcon(hInstance,MAKEINTRESOURCE(IDI_DIABLO));
			SendMessage(hDlg, WM_SETICON, (WPARAM) ICON_BIG | ICON_SMALL , (LPARAM) (HICON) hDiabloIcon);
			hHacksDlg = hDlg;
			HacksList = new CListView;
			HacksList->SetVars(hInstance,GetDlgItem(hDlg,IDC_HACKSLIST));
			HacksList->AddColumn("Name",0,200);
			HacksList->AddColumn("Version",1,60);
			HacksList->AddColumn("Status",2,60);
			HacksList->AttachImageList(IDB_HACKS);
			F_HACK = (CHack*) lParam;
			HacksDlgProc(hDlg,WM_COMMAND,IDC_REFRESH,NULL);
			return TRUE;

		case WM_DESTROY:
			HacksList->DeleteAllItems();
			delete HacksList;
			return TRUE;

		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDC_ACTIVATE:
					SetFocus(GetDlgItem(hHacksDlg,IDC_HACKSLIST));
					HacksList->ProcessSelected(ActivateHacksProc);
					HacksDlgProc(hDlg,WM_COMMAND,IDC_REFRESH,NULL);
					return TRUE;

				case IDC_DEACTIVATE:
					SetFocus(GetDlgItem(hHacksDlg,IDC_HACKSLIST));
					HacksList->ProcessSelected(DeactivateHacksProc);
					HacksDlgProc(hDlg,WM_COMMAND,IDC_REFRESH,NULL);
					return TRUE;
			
				case IDC_REFRESH:
					if(!GetDiabloProcID())
					{
						HacksList->DeleteAllItems();
						ShowWindow(GetDlgItem(hHacksDlg,IDC_ACTIVATE),SW_HIDE);
						ShowWindow(GetDlgItem(hHacksDlg,IDC_DEACTIVATE),SW_HIDE);
						ShowWindow(GetDlgItem(hHacksDlg,IDC_HIDDEN),SW_SHOW);
						//DisableDlg();
						C_HACK = F_HACK;
						index=0;
						do
						{
							HacksList->AddItem(index,0,C_HACK->szName,3,(LPARAM) C_HACK);
							HacksList->AddItem(index,1,C_HACK->szVersion,0,0);
							HacksList->AddItem(index,2,"NO PID",0,0);
							index++;
							C_HACK=C_HACK->Next;
						}while(C_HACK);

					}
					else
					{
						HacksList->DeleteAllItems();
						ShowWindow(GetDlgItem(hHacksDlg,IDC_ACTIVATE),SW_SHOW);
						ShowWindow(GetDlgItem(hHacksDlg,IDC_DEACTIVATE),SW_SHOW);
						ShowWindow(GetDlgItem(hHacksDlg,IDC_HIDDEN),SW_HIDE);
						//Refresh();
						C_HACK = F_HACK;
						index=0;
						do
						{
							tStat = C_HACK->GetStatus(hDiablo);
							HacksList->AddItem(index,0,C_HACK->szName,tStat,(LPARAM) C_HACK);
							HacksList->AddItem(index,1,C_HACK->szVersion,0,0);
							HacksList->AddItem(index,2,theStatus[tStat],0,0);
							index++;
							C_HACK=C_HACK->Next;
						}while(C_HACK);
					}
					return TRUE;
		
				case IDCANCEL:
					EndDialog(hHacksDlg,TRUE);
					return TRUE;

				default:
					return FALSE;
			}
		default:
			return FALSE;
	}
}

BOOL InitHacks(char *FileName)
{
	char *buffer = new char[512];
	char *tBuf[3];
	unsigned int a=0;
	CHack *C_HACK=NULL,
		  *P_HACK=NULL,
		  *F_HACK=NULL;
	COffset
		  *C_DATA=NULL,
		  *P_DATA=NULL,
		  *F_DATA=NULL;
	FILE  *HFILE=NULL;

	HFILE = fopen(FileName,"r");
	if(HFILE == NULL)
	{
		MsgBox(NULL, "Error",MB_OK | MB_ICONERROR,"Error opening file \"%s\"",FileName);
		return FALSE;
	}

	while(fgets(buffer,512,HFILE))
	{
		if(buffer[0]=='#' || buffer[0]=='\n' || buffer[0]==' ')
			continue;
		strtok(buffer,"\t\n ");
		if(!stricmp(buffer,"start"))
		{
			C_HACK = new CHack;
			if(!F_HACK)
				F_HACK = C_HACK;
			else
				P_HACK->Next=C_HACK;
			P_HACK = C_HACK;

			C_HACK->szVersion = strdup(strtok(NULL,"\t\n "));
			C_HACK->szName = strdup(strtok(NULL,"\n"));

			F_DATA=NULL;

			while(fgets(buffer,512,HFILE))
			{
				if(buffer[0]=='#' || buffer[0]=='\n')
					continue;
				strtok(buffer,"\n\t ");
				if(!stricmp(buffer,"end"))
				{
					C_HACK->Data = F_DATA;
					F_DATA=NULL;
					break;
				}
				
				C_DATA = new COffset;
				if(!F_DATA)
					F_DATA = C_DATA;
				else
					P_DATA->Next=C_DATA;
				P_DATA = C_DATA;

				C_DATA->offset = strtoul(buffer,NULL,16);

				tBuf[0] = strtok(NULL,"\t\n ");
				tBuf[1] = strtok(NULL,"\t\n ");

				BOOL tEnhanced=FALSE;
				
				if(tBuf[0][1]=='*' && tBuf[0][0] =='*')
					tEnhanced=TRUE;
				
				if( !C_DATA->offset || strlen(tBuf[0]) != strlen(tBuf[1]) && tEnhanced==FALSE)
				{
					MessageBox(NULL,"Error Parsing Dat File","Error",MB_OK | MB_ICONERROR);
					delete [] buffer;
					delete F_HACK;
					fclose(HFILE);
					return FALSE;
				}

				C_DATA->size = strlen(tBuf[0])>>1;
				C_DATA->Active = new unsigned char[C_DATA->size];
				if(tEnhanced==FALSE)
					C_DATA->InActive = new unsigned char[C_DATA->size];
				else
					C_DATA->InActive=NULL;

				tBuf[2] = (char *) calloc(3,1);
				for(a=0;a < C_DATA->size;a++)
				{
				
					if(!tEnhanced)
					{
						memcpy(tBuf[2],tBuf[0]+(2*a),2);
						C_DATA->InActive[a] = (char) strtoul(tBuf[2],NULL,16);
					}
					memcpy(tBuf[2],tBuf[1]+(2*a),2);
					C_DATA->Active[a] = (char) strtoul(tBuf[2],NULL,16);
				}
				free(tBuf[2]);
			}
		}
		else
		{
			MessageBox(NULL,"Error Parsing Dat File","Error",MB_OK | MB_ICONERROR);
			delete [] buffer;
			delete F_HACK;
			fclose(HFILE);
			return FALSE;
		}
	}
	delete [] buffer;
	fclose(HFILE);
	if(!F_HACK)
	{
		MessageBox(NULL,"No Hacks Could Be Parsed.","Error",MB_OK | MB_ICONERROR);
		return FALSE;
	}
	DialogBoxParam(hInstance,MAKEINTRESOURCE(IDD_HACKSDLG),NULL,(FARPROC) HacksDlgProc,(LPARAM) F_HACK);

	hHacksDlg = NULL;
	delete F_HACK;

	return TRUE;

}

BOOL WINAPI FilesDlgProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam)
{
static char *szIniFileName;
	switch(Msg)
	{
		case WM_INITDIALOG:
			szIniFileName = (char *) lParam;
			CheckDlgButton(hDlg,IDC_REG_CHA, BST_CHECKED);
			CheckDlgButton(hDlg,IDC_REG_ITM, BST_CHECKED);
			CheckDlgButton(hDlg,IDC_REG_DAT, BST_CHECKED);
			CheckDlgButton(hDlg,IDC_NOSHOWAGAIN, BST_CHECKED);
			return TRUE;

		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDOK:
					WritePrivateProfileString("FileTypes","Cha Files", (IsDlgButtonChecked(hDlg,IDC_REG_CHA)==BST_CHECKED) ? "1" : "0",szIniFileName);
					WritePrivateProfileString("FileTypes","Itm Files", (IsDlgButtonChecked(hDlg,IDC_REG_ITM)==BST_CHECKED) ? "1" : "0",szIniFileName);
					WritePrivateProfileString("FileTypes","Dat Files", (IsDlgButtonChecked(hDlg,IDC_REG_DAT)==BST_CHECKED) ? "1" : "0",szIniFileName);
					WritePrivateProfileString("FileTypes","NeverAsk", (IsDlgButtonChecked(hDlg,IDC_NOSHOWAGAIN)==BST_CHECKED) ? "1" : "0",szIniFileName);

				case IDCANCEL:
					EndDialog(hDlg,0);
					return TRUE;
			}
		
		default:
			return FALSE;
	}
}

void Initialize()
{
	char szModuleFileName[256];
	GetModuleFileName(hInstance, szModuleFileName, 255);
	strcpy(szModuleFileName+(strlen(szModuleFileName)-4),".INI");
	//MessageBox(NULL,szModuleFileName,"DEBUG", MB_OK);
	
	if(!GetPrivateProfileInt("FileTypes","NeverAsk",NULL,szModuleFileName))
		DialogBoxParam(hInstance,MAKEINTRESOURCE(IDD_FILESDLG),hSplashWnd,(FARPROC) FilesDlgProc, (LPARAM) szModuleFileName);
	if(GetPrivateProfileInt("FileTypes","Cha Files",NULL,szModuleFileName))
		RegisterFileType(".cha","DDTrainer.Character","Diablo Character File",4);
	if(GetPrivateProfileInt("FileTypes","Itm Files",NULL,szModuleFileName))
		RegisterFileType(".itm","DDTrainer.Item","Diablo Item File",4);
	if(GetPrivateProfileInt("FileTypes","Dat Files",NULL,szModuleFileName))
		RegisterFileType(".dat","DDTrainer.DatFile","Diablo Hack Data File",4);

}

int MsgBox(HWND hWnd, char *title ,int style,char* szError,...)
{
	int ret;
	char		szBuff[128];
	va_list		vl;
	va_start(vl, szError);
	vsprintf(szBuff, szError, vl);
	ret = MessageBox(hWnd, szBuff, title, style);
	va_end(vl);
	return ret;
}

long WINAPI SplashWndProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	HDC hWndDC;
	PAINTSTRUCT ps;
	static HANDLE hBitmap;
	static HDC hBmpDC;
	switch(Msg)
	{
		case WM_CREATE:
			SetTimer(hWnd, TIMER_START , 2000, (TIMERPROC) NULL);
			hBitmap = LoadImage(hInstance,"SPLASH",IMAGE_BITMAP, 500,100, LR_DEFAULTCOLOR );
			hBmpDC = CreateCompatibleDC(NULL);
			SelectObject(hBmpDC, hBitmap);
			
			return FALSE;


		case WM_TIMER:
			switch(wParam)
			{
				case TIMER_START:
					KillTimer(hWnd, TIMER_START);
					Initialize();
					hMainDlg = hSplashWnd;
					GetDiabloProcID();
					hMainDlg = NULL;
					SetTimer(hWnd, TIMER_SPLASH , 1000, (TIMERPROC) NULL);
					return FALSE;

				case TIMER_SPLASH:
					KillTimer(hWnd, TIMER_SPLASH);
					PostMessage(hWnd, WM_CLOSE, 0, 0);
					return FALSE;
			}
			return FALSE;

		case WM_PAINT:
			hWndDC = BeginPaint(hWnd, &ps);
			BitBlt(ps.hdc,
				ps.rcPaint.left,
				ps.rcPaint.top,
				ps.rcPaint.right-ps.rcPaint.left,
				ps.rcPaint.bottom-ps.rcPaint.top,
				hBmpDC,
				ps.rcPaint.left,
				ps.rcPaint.top,
				SRCCOPY);

			EndPaint(hWnd, &ps); 
			return FALSE;
	
		case WM_DESTROY:
			DeleteDC(hBmpDC);
			DeleteObject(hBitmap);
			PostQuitMessage(0);
			return FALSE;
	
	}
	return DefWindowProc(hWnd,Msg,wParam,lParam);
}


void TabInsert(HWND hTabControl, int Item, LPSTR Tag)
{
	TC_ITEM ti;
	ti.mask = TCIF_TEXT;
	ti.pszText = Tag;
	TabCtrl_InsertItem(hTabControl, Item, &ti);
}

BOOL WINAPI ItemTab0Proc(HWND hDlg, int Msg, WPARAM wParam, LPARAM lParam)
{
	static HBITMAP hBitMap = NULL;
	char		szBuff[128];

	static _ItemStruct *pNewItem;
	int i;
	BOOL bQItem;

	switch(Msg)
	{
	case WM_INITDIALOG:
		SetWindowPos(hDlg, HWND_TOP, 3, 25, 0, 0, SWP_NOSIZE | SWP_SHOWWINDOW);
		pNewItem = (_ItemStruct*) lParam;

		SetDlgItemText(hDlg,IDC_IDEDNAME,pNewItem->IDedName);
		SendDlgItemMessage(hDlg,IDC_IDEDNAME,EM_LIMITTEXT,63,NULL);
		SetDlgItemText(hDlg,IDC_UNIDNAME,pNewItem->UnIDName);
		SendDlgItemMessage(hDlg,IDC_UNIDNAME,EM_LIMITTEXT,63,NULL);
		if(pNewItem->IDFlag) CheckDlgButton(hDlg, IDC_IDED, BST_CHECKED);
		SendDlgItemMessage(hDlg, IDC_MPROPERTIES, CB_ADDSTRING, 0, (LPARAM)"Normal");
		SendDlgItemMessage(hDlg, IDC_MPROPERTIES, CB_ADDSTRING, 0, (LPARAM)"Magical");
		SendDlgItemMessage(hDlg, IDC_MPROPERTIES, CB_ADDSTRING, 0, (LPARAM)"Unique");
		for(i=0; i < NUM_OF_GRAPHS; i++)
		{
			SendDlgItemMessage(hDlg, IDC_L_GRAPHIC, CB_ADDSTRING, 0, (LPARAM)GraphicNames[i]);
		}
		SendDlgItemMessage(hDlg, IDC_L_GRAPHIC, CB_SETCURSEL, pNewItem->ItemGraphic, 0);
		strcpy(szBuff,"IDB_OBJCURS_000");
		sprintf( szBuff + 12 ,"%03u", pNewItem->ItemGraphic+11);
		if(hBitMap)	DeleteObject(hBitMap);
		hBitMap = LoadBitmap(hInstance,szBuff);
		SendDlgItemMessage(hDlg, IDC_D_GRAPHIC,	STM_SETIMAGE,(WPARAM) IMAGE_BITMAP,(LPARAM) hBitMap);
		SendDlgItemMessage(hDlg, IDC_MPROPERTIES, CB_SETCURSEL, pNewItem->ItemType, 0);
		for(i=0,bQItem=TRUE; i < 16; i++)
		{
			SendDlgItemMessage(hDlg, IDC_ITEMTYPE, CB_ADDSTRING, 0, (LPARAM)ItemTypes[i].Desc);
			if(bQItem)
			{
				if((pNewItem->EquipType==ItemTypes[i].Placement)&&(pNewItem->EquipClass==ItemTypes[i].Class)&&(pNewItem->EncodedType==ItemTypes[i].Type))
				{
					bQItem=FALSE;
					SendDlgItemMessage(hDlg, IDC_ITEMTYPE, CB_SETCURSEL, i, 0);
				}
			}
		}
		if(bQItem)
		{
			ItemTypes[16].Placement = pNewItem->EquipType;
			ItemTypes[16].Type = pNewItem->EncodedType;
			ItemTypes[16].Class = pNewItem->EquipClass;
			SendDlgItemMessage(hDlg, IDC_ITEMTYPE, CB_ADDSTRING, 0, (LPARAM)ItemTypes[16].Desc);
			SendDlgItemMessage(hDlg, IDC_ITEMTYPE, CB_SETCURSEL, 16, 0);
		}
		return TRUE;

	case WM_DESTROY:
		GetDlgItemText(hDlg,IDC_UNIDNAME, pNewItem->UnIDName,64);
		GetDlgItemText(hDlg,IDC_IDEDNAME, pNewItem->IDedName,64);
		pNewItem->IDFlag = (IsDlgButtonChecked(hDlg, IDC_IDED)==BST_CHECKED);
		pNewItem->ItemGraphic = SendDlgItemMessage(hDlg, IDC_L_GRAPHIC, CB_GETCURSEL, 0, 0);
		pNewItem->ItemType = (unsigned char) SendDlgItemMessage(hDlg, IDC_MPROPERTIES, CB_GETCURSEL, 0, 0);
		i = SendDlgItemMessage(hDlg, IDC_ITEMTYPE, CB_GETCURSEL, 0, 0);
		pNewItem->EquipType = ItemTypes[i].Placement;
		pNewItem->EncodedType = ItemTypes[i].Type;
		pNewItem->EquipClass = ItemTypes[i].Class;
		return TRUE;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_L_GRAPHIC:
			if(HIWORD(wParam) == CBN_SELCHANGE)
			{
				strcpy(szBuff,"IDB_OBJCURS_000");
				sprintf( szBuff + 12 ,"%03u", SendDlgItemMessage(hDlg, IDC_L_GRAPHIC, CB_GETCURSEL, 0, 0)+11);
				if(hBitMap)	DeleteObject(hBitMap);
				hBitMap = LoadBitmap(hInstance,szBuff);
				SendDlgItemMessage(hDlg, IDC_D_GRAPHIC,	STM_SETIMAGE,(WPARAM) IMAGE_BITMAP,(LPARAM) hBitMap);
				return TRUE;
			}
			return FALSE;
		default:
			return FALSE;
		}
	}
	return FALSE;
}

BOOL WINAPI ItemTab1Proc(HWND hDlg, int Msg, WPARAM wParam, LPARAM lParam)
{
	static _ItemStruct *pNewItem;
	int i;
	switch(Msg)
	{
	case WM_INITDIALOG:
		SetWindowPos(hDlg, HWND_TOP, 3, 25, 0, 0, SWP_NOSIZE | SWP_SHOWWINDOW);
		pNewItem = (_ItemStruct*) lParam;
		for(i = 0; i < 7; i++)
		{
			if(pNewItem->SAF1 & SAFS[i].data) CheckDlgButton(hDlg, SAFS[i].control, BST_CHECKED);
			if((i<4)&&(pNewItem->SAF2 & SAFS[i+7].data))
				CheckDlgButton(hDlg, SAFS[i+7].control, BST_CHECKED);
			if(!i)
			{
				if(pNewItem->SAF3 & SAFS[i+11].data) CheckDlgButton(hDlg, SAFS[i+11].control, BST_CHECKED);
				if(pNewItem->SAF4 & SAFS[i+12].data) CheckDlgButton(hDlg, SAFS[i+12].control, BST_CHECKED);
			}
		}
		return TRUE;

	case WM_DESTROY:
		for(i = 0; i < 7; i++)
		{
			(IsDlgButtonChecked(hDlg, SAFS[i].control)==BST_CHECKED) ? pNewItem->SAF1 |= SAFS[i].data : pNewItem->SAF1 &= (0xFF ^ SAFS[i].data);
			if(i<4)
				(IsDlgButtonChecked(hDlg, SAFS[i+7].control)==BST_CHECKED) ? pNewItem->SAF2 |= SAFS[i+7].data : pNewItem->SAF2 &= (0xFF ^ SAFS[i+7].data);
			if(!i)
			{
				(IsDlgButtonChecked(hDlg, SAFS[i+11].control)==BST_CHECKED) ? pNewItem->SAF3 |= SAFS[i+11].data : pNewItem->SAF3 &= (0xFF ^ SAFS[i+11].data);
				(IsDlgButtonChecked(hDlg, SAFS[i+12].control)==BST_CHECKED) ? pNewItem->SAF4 |= SAFS[i+12].data : pNewItem->SAF4 &= (0xFF ^ SAFS[i+12].data);
			}
		}
		return TRUE;

	case WM_COMMAND:
		return FALSE;
	}
	return FALSE;
}

BOOL WINAPI ItemTab2Proc(HWND hDlg, int Msg, WPARAM wParam, LPARAM lParam)
{
	static _ItemStruct *pNewItem;
	int i;
	switch(Msg)
	{
	case WM_INITDIALOG:
		SetWindowPos(hDlg, HWND_TOP, 3, 25, 0, 0, SWP_NOSIZE | SWP_SHOWWINDOW);
		pNewItem = (_ItemStruct*) lParam;
		for(i = 0; i < 7; i++)
		{
			if(pNewItem->SAF3 & SAFS[i+13].data) CheckDlgButton(hDlg, SAFS[i+13].control, BST_CHECKED);
			if((i<6)&&(pNewItem->SAF4 & SAFS[i+20].data))
				CheckDlgButton(hDlg, SAFS[i+20].control, BST_CHECKED);
		}
		return TRUE;

	case WM_DESTROY:
		for(i = 0; i < 7; i++)
		{
			(IsDlgButtonChecked(hDlg, SAFS[i+13].control)==BST_CHECKED) ? pNewItem->SAF3 |= SAFS[i+13].data : pNewItem->SAF3 &= (0xFF ^ SAFS[i+13].data);
			if(i<6)
				(IsDlgButtonChecked(hDlg, SAFS[i+20].control)==BST_CHECKED) ? pNewItem->SAF4 |= SAFS[i+20].data : pNewItem->SAF4 &= (0xFF ^ SAFS[i+20].data);
		}
		return TRUE;

	case WM_COMMAND:
		return FALSE;
	}
	return FALSE;
}

BOOL WINAPI CompDlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_INITDIALOG:
		CheckDlgButton(hDlg, IDC_DIABLOV9, BST_CHECKED);
		return TRUE;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDOK:
			if(IsDlgButtonChecked(hDlg, IDC_DIABLOV7) == BST_CHECKED)
			{
				GROUND = GROUND_7;
				VERSTR = VERSTR_7;
				CHARSLOT = CHARSLOT_7;
				CHAROFFSET = CHAROFFSET_7;
				NAMEOFFSET = NAMEOFFSET_7;
				strcpy(DIABLOVERSION, DIABLOVERSION_7);
			}
			if(IsDlgButtonChecked(hDlg, IDC_DIABLOV8) == BST_CHECKED)
			{
				GROUND = GROUND_8;
				VERSTR = VERSTR_8;
				CHARSLOT = CHARSLOT_8;
				CHAROFFSET = CHAROFFSET_8;
				NAMEOFFSET = NAMEOFFSET_8;
				strcpy(DIABLOVERSION, DIABLOVERSION_8);
			}
			if(IsDlgButtonChecked(hDlg, IDC_DIABLOV9) == BST_CHECKED)
			{
				GROUND = GROUND_9;
				VERSTR = VERSTR_9;
				CHARSLOT = CHARSLOT_9;
				CHAROFFSET = CHAROFFSET_9;
				NAMEOFFSET = NAMEOFFSET_9;
				strcpy(DIABLOVERSION, DIABLOVERSION_9);
			}
			EndDialog(hDlg, TRUE);
			return TRUE;

		case IDCANCEL:
			hDiablo = NULL;
			EndDialog(hDlg, FALSE);
			return TRUE;
		}
	}
	return FALSE;
}
