#include "includes.h"


CListView::CListView()
{
}

BOOL CListView::SetVars(HINSTANCE hInst,HWND hWnd)
{
	hInstance = hInst;
	hWndList = hWnd;
	return TRUE;
}

int CListView::AddItem(int index,int iSubItem,char *label,int iImage, LPARAM Data)
{
	if(iSubItem)
	{
		ListView_SetItemText(hWndList,index,iSubItem,label);
		return index;
	}
	LV_ITEM lvI;
	lvI.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
	lvI.iItem = index;
	lvI.iSubItem = 0;
	lvI.pszText = label;
	lvI.iImage = iImage;
	lvI.lParam = Data;
	return ListView_InsertItem(hWndList, &lvI);
}

BOOL CListView::AddColumn(char * label,int iSubItem, int width)
{

	LV_COLUMN lvc;
	lvc.mask = LVCF_TEXT | LVCF_WIDTH | LVCF_SUBITEM;
	lvc.iSubItem = iSubItem;
	lvc.cx = width;
	lvc.pszText=label;
	ListView_InsertColumn(hWndList,iSubItem, &lvc);
	return TRUE;
}

BOOL CListView::DeleteAllItems()
{
	return ListView_DeleteAllItems(hWndList);
}

void CListView::AttachImageList(int hBitmap)
{
	HIMAGELIST hImageList;
	hImageList = ImageList_LoadBitmap(hInstance,MAKEINTRESOURCE(hBitmap),16,0,(COLORREF)0x00FF00FF);
    //ImageList_SetBkColor(hImageList,0x00FF00FF);
	ListView_SetImageList(hWndList, hImageList, LVSIL_SMALL);
}

int CListView::ProcessSelected(void(*funcPtr)(LPARAM))
{
	LV_ITEM lvI;
	lvI.mask = LVIF_PARAM;
	int index,Count = ListView_GetItemCount(hWndList);
	for(index=0;index<Count;index++)
	{
		if(ListView_GetItemState(hWndList,index,LVIS_SELECTED))
		{
			lvI.iItem=index;
			lvI.iSubItem=0;
			ListView_GetItem(hWndList,&lvI);
			funcPtr(lvI.lParam);
		}
	}
	return TRUE;
}
